unit RTOSDemoDefs;

interface

const
  RTOSKEYNAME = 'Embedded RTOS debug module';
  MAXTASKS = 10;
  MAXSEMAPHORES = 10;
  MAXTIMERS = 10;

type
  TSTATUS = (
    stOK,
    stNO_HANDLE,
    stTIMEOUT
  ); // TSTATUS
  TTaskState = (
    taTASK_SUSPENDED,
    taTASK_WAITING,
    taTASK_SEMA_WAIT,
    taTASK_RUNNING
  ); // TTaskState
  TTaskStateName = array[TTaskState] of string;

  TTimerState = (
    tiTIMER_STOPPED,
    tiTIMER_RUNNING
  ); // TTimerState
  TTimerStateName = array[TTimerState] of string;

  pchar16 = WORD;
  int16 = smallint;
  ADDR16 = WORD;
  TFptr16 = WORD;
  TTaskState16 = WORD;
  pvoid16 = WORD;
  pttask16 = WORD;
  TTimerState16 = WORD;

  TTask16 = record
    Name : pchar16; // char *Name;
    Handle : int16; // int Handle;
    Index : int16; // int Index;
    Fptr : TFptr16; // TFptr Fptr;
    Pc : TFptr16; // TFptr Pc;
    Sp : ADDR16; // ADDR Sp;
    Saveaddr : ADDR16; // ADDR Saveaddr;
    SpAddr : ADDR16; // ADDR SpAddr;
    StartOver : int16; // int StartOver;
    State : TTaskState16; // TTaskState State;
    WaitTime : int16; // int WaitTime;
    WaitReturn : int16; // int WaitReturn;
    Timer : pvoid16; // void* Timer; /*TTimer */
    Semaphore : pvoid16; // void* Semaphore; /*TSemaphore */
  end; // TTask16

  TSema16 = record
    Name : pchar16; // char *Name;
    Handle : int16; // int Handle;
    Value : int16; // int Value;
    MaxValue : int16; // int MaxValue;
    // TTask* Queue[MAXTASKS];
    Queue : array[0 .. MAXTASKS - 1] of pttask16; 
  end; // TSema16

  TTimer16 = record
    Name : pchar16; // char *Name;
    Handle : int16; // int Handle;
    Value : int16; // int Value;
    Cnt : int16; // int Cnt;
    State : TTimerState16; // TTimerState State;
    Task : pttask16; // TTask* Task;
  end; // TTimer16

  TApp16 = record
    MaxTasks : int16; // int MaxTasks;
    MaxSemas : int16; // int MaxSemas;
    MaxTimers : int16; // int MaxTimers;
    // TTask TaskArray[MAXTASKS];
    TaskArray : array[0 .. MAXTASKS - 1] of TTask16;
    // TSemaphore SemaArray[MAXSEMAPHORES];
    SemaArray : array[0 .. MAXSEMAPHORES - 1] of TSema16;
    // TTimer TimerArray[MAXTIMERS];
    TimerArray : array[0 .. MAXTIMERS - 1] of TTimer16;
    RunningTask : pttask16; // TTask* RunningTask;
    temp : int16; // int temp;
  end; // TApp16

const
  TaskStateName : TTaskStateName = (
    'Suspended',
    'Waiting',
    'Waiting for Semaphore',
    'Running'
  ); // TTaskStateName
  TimerStateName : TTimerStateName = (
    'Stopped',
    'Running'
  ); // TTimerStateName


implementation

end.
